#ifndef byteque_h
#define byteque_h

#include "local.h"

typedef struct {
  unsigned  len;
  unsigned  inQueue;
  unsigned  head;
  unsigned  tail;
  unsigned  maxInQueue;
  BYTE     *buf;
} volatile BYTEQUEUE;

BYTEQUEUE *BYTEQUEUE_open(unsigned sz);
void       BYTEQUEUE_close(BYTEQUEUE *que);
BOOL       BYTEQUEUE_enqueue(BYTEQUEUE *que, int byte);
int        BYTEQUEUE_dequeue(BYTEQUEUE *que);
#define BYTEQUEUE_isEmpty(que) ((que)->inQueue == 0)

#endif
